/**
 *
 * Magnolia Criteria API (http://www.openmindlab.com/lab/products/mgnlcriteria.html)
 * Copyright (C)2009 - 2010, Openmind S.r.l. http://www.openmindonline.it
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sourceforge.openutils.mgnlcriteria.jcr.query.xpath.impl;

import junit.framework.Assert;
import net.sourceforge.openutils.mgnlcriteria.jcr.query.Criteria;
import net.sourceforge.openutils.mgnlcriteria.jcr.query.JCRCriteriaFactory;
import net.sourceforge.openutils.mgnlcriteria.jcr.query.criterion.Junction;
import net.sourceforge.openutils.mgnlcriteria.jcr.query.criterion.Restrictions;

import org.junit.Test;


/**
 * @author fgiust
 * @version $Id: MagnoliaCriteriaTest.java 1619 2010-01-09 14:09:02Z fgiust $
 */
public class MagnoliaCriteriaTest
{

    @Test
    public void testSimple()
    {
        Criteria criteria = JCRCriteriaFactory.createMgnlCriteria("//site//*", null, "mgnl:content");

        Junction conjunction = Restrictions.conjunction();
        criteria.add(conjunction);
        conjunction.add(Restrictions.eq("@property", "test"));
        conjunction.add(Restrictions.eq("@anotherproperty", "anothertest"));

        String xpathExpression = criteria.toXpathExpression();
        Assert.assertEquals(
            "//site//*[(( (@property='test')  and  (@anotherproperty='anothertest') ) )] ",
            xpathExpression);

    }

    /**
     * Test for CRIT-3
     */
    @Test
    public void testEmptyConjuntion()
    {
        Criteria criteria = JCRCriteriaFactory.createMgnlCriteria("//site//*", null, "mgnl:content");

        criteria.add(Restrictions.eq("@property", "test"));

        Junction conjunction = Restrictions.conjunction();
        criteria.add(conjunction);

        String xpathExpression = criteria.toXpathExpression();
        Assert.assertEquals("//site//*[( (@property='test')  )] ", xpathExpression);

    }
}
